using System;
using System.Collections.Generic;

namespace SSTPLib {
    /// <summary>
    /// FINE FMÔPf[^iPAvP[Vj\NXł
    /// </summary>
    public class FineFMOData {
        string m_ApplicationName;
        Dictionary<string, List<string>> m_property = new Dictionary<string, List<string>>();

        /// <summary>
        /// RXgN^
        /// </summary>
        /// <param key="appname">AvP[V</param>
        public FineFMOData(string appname) {
            m_ApplicationName = appname;
        }

        /// <summary>
        /// AvP[V擾܂
        /// </summary>
        public string AppicationName {
            get { return m_ApplicationName; }
        }

        /// <summary>
        /// vpeB擾܂
        /// </summary>
        /// <param key="key">L[</param>
        /// <returns>vpeB</returns>
        public string[] GetProperty(string key) {
            if (m_property.ContainsKey(key)) {
                List<string> ar = m_property[key];
                string[] vals = new string[ar.Count];
                ar.CopyTo(vals, 0);
                return vals;
            } else {
                return null;
            }
        }

        /// <summary>
        /// vpeBݒ肵܂
        /// </summary>
        /// <param key="key">L[</param>
        /// <param key="val">vpeBl</param>
        public void SetProperty(string key, string val) {
            if (m_property.ContainsKey(key)) {
                //
            } else {
                m_property[key] = new List<string>();
            }
            List<string> ar = m_property[key];
            ar.Add(val);
        }

        /// <summary>
        /// ݂vpeB񋓂܂
        /// </summary>
        /// <returns>vpeB</returns>
        public string[] GetPropertyNames() {
            if (m_property.Keys.Count == 0) {
                return null;
            }
            string[] keys = new string[m_property.Keys.Count];
            m_property.Keys.CopyTo(keys, 0);
            return keys;
        }
    }


    /// <summary>
    /// FINE FMO ̓e\NXłB
    /// </summary>
    public class FineFMO : IFMOReader {
        private FMO m_FMO;
        private Dictionary<string, FineFMOData> m_FineData;

        /// <summary>
        /// RXgN^FFMO "Fine"
        /// </summary>
        public FineFMO() : this("Fine") { }

        /// <summary>
        /// RXgN^
        /// </summary>
        /// <param name="fmoname">FMO</param>
        public FineFMO(string fmoname) {
            m_FMO = new FMO(fmoname);
        }

        /// <summary>
        /// FMO̓eǂݍ݂܂
        /// </summary>
        /// <param name="isUseMutex">ǂݍ݂MutexgꍇTRUE</param>
        /// <returns>ǂݍݐ^s</returns>
        public bool Update(bool isUseMutex) {
            if (m_FMO.UpdateData(isUseMutex) == true) {
                return ParseFMO(m_FMO.FMOString);
            } else {
                return false;
            }
        }

        /// <summary>
        /// AvP[Ṽf[^擾܂
        /// </summary>
        /// <param name="appname">AvP[V</param>
        /// <returns>AvP[Ṽf[^\FineFMODataB݂ȂꍇnullԂ܂</returns>
        public FineFMOData GetApplicationData(string appname) {
            if (m_FineData == null) {
                return null;
            }
            if (m_FineData.ContainsKey(appname)) {
                return (FineFMOData)m_FineData[appname];
            } else {
                return null;
            }
        }

        /// <summary>
        /// AvP[V񋓂܂
        /// </summary>
        /// <returns>AvP[V̔z</returns>
        public String[] GetApplicationNames() {
            if (m_FineData == null) {
                return null;
            }
            if (m_FineData.Keys.Count == 0) {
                return null;
            }
            string[] keys = new string[m_FineData.Keys.Count];
            m_FineData.Keys.CopyTo(keys, 0);
            return keys;
        }

        /// <summary>
        /// FMO
        /// </summary>
        /// <param name="fmodata">f[^</param>
        /// <returns>^s</returns>
        private bool ParseFMO(string fmodata) {
            m_FineData = new Dictionary<string, FineFMOData>();
            if (fmodata == null) {
                return false;
            }
            string[] lines = fmodata.Split(new char[] { '\n' });
            for (int i = 0; i < lines.Length; i++) {
                string[] tokens = lines[i].Split(new char[] { ':' });
                if (tokens.Length != 3) {
                    System.Diagnostics.Debug.WriteLine("illegal line:" + lines[i]);
                    continue;
                }
                string appname = tokens[0];
                string propname = tokens[1];
                string val = tokens[2];
                if (!m_FineData.ContainsKey(appname)) {
                    m_FineData[appname] = new FineFMOData(appname);
                }
                FineFMOData fd = (FineFMOData)m_FineData[appname];
                fd.SetProperty(propname, val);
            }
            return true;
        }
    }
}
